#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;
const int maxm = 400005;

int n, m, q;

struct Edge
{
    int x;
    int y;
    int w;
};

Edge edges[maxm];

struct DSU
{
    int par[maxn];
    int sz[maxn];

    void init()
    {
        for (int i = 1; i <= n; ++i)
        {
            par[i] = i;
            sz[i] = 1;
        }
    }

    int root(int node)
    {
        if (node == par[node])
        {
            return node;
        }

        return par[node] = root(par[node]);
    }

    void connect(int x, int y)
    {
        x = root(x);
        y = root(y);

        if (x == y)
        {
            return;
        }

        if (sz[x] < sz[y])
        {
            par[x] = y;
            sz[y] += sz[x];
        }
        else
        {
            par[y] = x;
            sz[x] += sz[y];
        }
    }

    bool areConnected(int x, int y)
    {
        return root(x) == root(y);
    }
};

DSU dsu;

vector<pair<int, int>> byNode[maxn];
int answers[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> q;

    for (int i = 1; i <= m; ++i)
    {
        cin >> edges[i].x >> edges[i].y >> edges[i].w;
    }

    sort(edges + 1, edges + m + 1, [&](const Edge& A, const Edge& B)
    {
        return A.w < B.w;
    });

    for (int i = 1; i <= q; ++i)
    {
        int x, k;
        cin >> x >> k;
        byNode[x].push_back({k, i});
    }

    for (int i = 1; i <= n; ++i)
    {
        sort(byNode[i].begin(), byNode[i].end());
    }

    for (int i = 1; i <= n; ++i)
    {
        if (byNode[i].empty()) continue;

        dsu.init();

        int ptr = 0;

        //cout << "on node " << i << endl;

        for (auto [k, idx] : byNode[i])
        {
            //cout << "want " << k << " " << idx << endl;
            while (dsu.sz[dsu.root(i)] <= k)
            {
                ++ptr;
                dsu.connect(edges[ptr].x, edges[ptr].y);
            }

            answers[idx] = edges[ptr].w;
        }
    }

    for (int i = 1; i <= q; ++i)
    {
        cout << answers[i] << "\n";
    }

    return 0;
}
