#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n;
int a[maxn];
vector<pair<int, int>> v;

struct FenwickTree
{
    int tree[maxn];

    void update(int pos, int add)
    {
        for (int i = pos; i <= n; i += (i & (-i)))
        {
            tree[i] += add;
        }
    }

    int query(int pos)
    {
        int ans = 0;

        for (int i = pos; i >= 1; i -= (i & (-i)))
        {
            ans += tree[i];
        }

        return ans;
    }
};

FenwickTree bit[21];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        bit[a[i]].update(i, +1);
        v.push_back(make_pair(a[i], i));
    }

    sort(v.begin(), v.end());

    int pos = 1;
    int ans = 0;

    for (auto [num, idx] : v)
    {
        int idxNew = idx + (bit[0].query(n) - bit[0].query(idx));
        ans += idxNew - pos;
        ++pos;

        for (int i = 1; i <= 20; ++i)
        {
            int cnt = bit[i].query(idx);

            //cout << num << " -> " << i << " :: " << cnt << endl;

            if (cnt > 0 && (num % i != 0 && i % num != 0))
            {
                cout << num << endl;
                cout << -1 << endl;
                return 0;
            }
        }

        bit[0].update(idx, +1);
        bit[num].update(idx, -1);
    }

    cout << ans << endl;

    return 0;
}
