#include <bits/stdc++.h>
using namespace std;

const int MAXNODES = 3 * 1e5 + 7;
const bool ADD = true;
const bool SUB = false;

struct Node{
    int left, right;
    bool op;
};

int n, m;
int idxTab[65][65];
int sumTab[65][65];
Node nodes[MAXNODES];

int nodeIdx;

void printState(){
    cout << nodeIdx-1 << '\n';
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            if(sumTab[i][j] != 0){
                cout << sumTab[i][j] << ' ';
            }else{
                cout << ". ";
            }
        }
        cout << '\n';
    }

    for(int i = n*m+1; i < nodeIdx; i++){
        cout << i << " = " << nodes[i].left << ' ' << (nodes[i].op?'+':'-') << ' ' << nodes[i].right << '\n';
    }
}

int addNode(int left, int right, bool op){
    nodes[nodeIdx] = {left, right, op};
    return nodeIdx++;
}

int main(){
    cin >> n >> m;
    nodeIdx = n*m+1;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            idxTab[i][j] = (i-1)*m + j;
        }
    }

    sumTab[1][1] = 1;
    int lastAdded;

    lastAdded = 1;
    for(int i = 2; i <= n; i++){
        Node nnode = {lastAdded, idxTab[i][1], ADD};
        nodes[nodeIdx] = nnode;
        lastAdded = nodeIdx++;
        sumTab[i][1] = lastAdded;
    }
    lastAdded = 1;
    for(int i = 2; i <= m; i++){
        Node nnode = {lastAdded, idxTab[1][i], ADD};
        nodes[nodeIdx] = nnode;
        lastAdded = nodeIdx++;
        sumTab[1][i] = lastAdded;
    }


    for(int i = 2; i <= n; i++){
        for(int j = 2; j <= m; j++){
            int sumPrevNode = addNode(sumTab[i-1][j], sumTab[i][j-1], ADD);
            int sumNode = addNode(sumPrevNode, idxTab[i][j], ADD);
            sumTab[i][j] = addNode(sumNode, sumTab[i-1][j-1], SUB);
        }
    }


    printState();

    return 0;
}
