#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 4e3 + 50;
class Graph
{
private:
    struct Node
    {
        int node, price;
        Node(){}
        Node(int node, int price)
            :node(node), price(price){}

        friend bool operator< (const Node a, const Node b)
        {
            return (a.price < b.price);
        }

    };
    priority_queue <Node> pq;
    vector <Node> graph[MAXN];
    vector <int> lowestPrices[MAXN];
    bool used[MAXN];

    void FillArray(const int origin, int currNode, int maxValue)
    {
        if (currNode != origin)
            lowestPrices[origin].push_back(maxValue);
        used[currNode] = true;

        for (Node next:graph[currNode])
        {
            if (used[next.node] == true)
                continue;

            pq.emplace(next.node, -next.price);
        }

        while (!pq.empty())
        {
            Node top = pq.top();
            pq.pop();
            if (used[top.node])
                continue;

            FillArray(origin, top.node, max(maxValue, -top.price));
        }
    }
public:
    Graph(){}

    void AddEdge(int u, int v, int price)
    {
        graph[u].emplace_back(v, price);
        graph[v].emplace_back(u, price);
    }

    void Solve()
    {

        for (int i = 1; i < MAXN; i++)
        {
            memset(used, false, sizeof(used));
            FillArray(i, i, 0);
            sort (lowestPrices[i].begin(), lowestPrices[i].end());
        }

    }

    int AnswerQuery(int x, int k)
    {
        return lowestPrices[x][k-1];
    }
};

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M, Q;
    cin >> N >> M >> Q;

    Graph *graph = new Graph();
    for (int i = 0; i < M; i++)
    {
        int u, v, price;
        cin >> u >> v >> price;

        graph->AddEdge(u, v, price);
    }

    graph->Solve();
    for (int i = 0; i < Q; i++)
    {
        int x, k;
        cin >> x >> k;

        cout << graph->AnswerQuery(x, k) << endl;
    }
    return 0;
}

/*
13 18 7
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 6
7 9
3 1
13 12
12 1
8 2
5 6
*/
