#include<iostream>
#include<algorithm>
#include<map>
#include<cmath>
#include<vector>
#include<queue>
using namespace std;
const long long MAX_N=2e5+5;
const long long LOG=18;
vector<pair<long long,long long>>queries;
vector<pair<long long,long long>>v;
long long a[MAX_N];
long long n;

long long tree[MAX_N];
long long Find(long long pos)
{
    long long sum=0;
    for(;;)
    {
        if(pos<1)break;
        sum+=tree[pos];
        pos-=((pos)&(-pos));
    }
    return sum;
}
void Update(long long pos,long long val)
{
    for(;;)
    {
        if(pos>n)break;
        tree[pos]+=val;
        pos+=((pos)&(-pos));
    }
}

long long gc[MAX_N];
long long FindG(long long pos)
{
    long long sum=0;
    for(;;)
    {
        if(pos<1)break;
        sum=__gcd(sum,tree[pos]);
        pos-=((pos)&(-pos));
    }
    return sum;
}
void UpdateG(long long pos,long long val)
{
    for(;;)
    {
        if(pos>n)break;
        tree[pos]=__gcd(val,tree[pos]);
        pos+=((pos)&(-pos));
    }
}

signed main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        v.push_back({a[i],i});
    }
    sort(v.begin(),v.end());

    bool ok=1;
    long long ans=0;

    for(auto [val,pos]:v)
    {
        long long curpos=pos;

        queries.push_back({curpos,val});
        ans+=curpos-Find(curpos)-1;
        Update(curpos,+1);
    }

    for(long long i=0;i<=n;i++)tree[i]=0;

    reverse(v.begin(),v.end());

    for(auto [val,pos]:v)
    {
        UpdateG(pos,val);

        if(FindG(queries.back().first)%queries.back().second!=0){ok=0;break;}

        queries.pop_back();
    }

    if(ok)cout<<ans<<"\n";
    else cout<<-1<<"\n";


    return 0;
}
