#include<iostream>
#include<map>
#include<tuple>
#include<algorithm>
#include<vector>
using namespace std;
const int MAX_N=70;
const int LOG=7;

int n,m;

int cnt;

map<int,pair<int,int>>s;

int spars[2][MAX_N][MAX_N][LOG];
int fen[2][MAX_N][MAX_N];
int high[MAX_N];

int tree[2][4*MAX_N][4*MAX_N];
int dist[2][4*MAX_N][4*MAX_N];

void makespars(int row,bool rot)
{
    /*for(int j=1;j<LOG;j++)
    {
        for(int i=(1<<j);i<=(rot==0 ? m : n);i++)
        {
            int left=spars[rot][row][i-(1<<(j-1))][j-1];
            int right=spars[rot][row][i][j-1];
            s[++cnt]={left,right};
            spars[rot][row][i][j]=cnt;
        }
    }*/

    for(int i=2;i<=(rot==0 ? m : n);i++)
    {
        for(int j=1;j<=high[i];j++)
        {
            int left=spars[rot][row][i-(1<<(j-1))][j-1];
            int right=spars[rot][row][i][j-1];
            s[++cnt]={left,right};
            spars[rot][row][i][j]=cnt;
        }
    }
}

void makefen(int row,bool rot)
{
    for(int i=1;i<=(rot==0 ? m : n);i++)
    {
        int left=fen[rot][row][i-(1<<high[i])];
        int right=spars[rot][row][i][high[i]];

        if(left==0)
        {
            fen[rot][row][i]=right;
        }
        else
        {
            s[++cnt]={left,right};
            fen[rot][row][i]=cnt;
        }
    }
}

void makeseg(int row,bool rot,int node,int l,int r)
{
    if(l==r)
    {
        tree[rot][row][node]=(row-1)*m+l;//row==0
        return;
    }

    int curidx=++cnt;

    int mid=(l+r)/2;

    makeseg(row,rot,2*node,l,mid);
    makeseg(row,rot,2*node+1,mid+1,r);

    tree[rot][row][node]=curidx;
    s[curidx]={tree[rot][row][2*node],tree[rot][row][2*node+1]};

    dist[rot][row][node]=max(dist[rot][row][2*node],dist[rot][row][2*node+1])+1;
}

vector<pair<int,int>> query(int row,bool rot,int node,int l,int r,int ql,int qr)
{
    if(ql<=l && r<=qr)return {{dist[rot][row][node],tree[rot][row][node]}};
    int mid=(l+r)/2;
    vector<pair<int,int>>cur;
    if(ql<=mid)cur=query(row,rot,2*node,l,mid,ql,qr);
    if(qr>mid)
    {
        auto cur2=query(row,rot,2*node+1,mid+1,r,ql,qr);

        if(cur2.size()>cur.size())swap(cur,cur2);

        for(auto pa:cur2)cur.push_back(pa);
    }
    return cur;
}

int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    for(int i=1;i<=64;i++)
    {
        for(int j=LOG-1;j>=0;j--)
        {
            if(((1<<j)&(i))!=0){high[i]=j;break;}
        }
    }

    cin>>n>>m;
    cnt=n*m;

    /*for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            spars[0][i][j][0]=(i-1)*m+j;
        }
        makespars(i,0);
        makefen(i,0);
    }*/
    for(int i=1;i<=n;i++)
    {
        makeseg(i,0,1,1,m);
        for(int j=1;j<=m;j++)
        {
            auto cur=query(i,0,1,1,m,1,j);
            sort(cur.begin(),cur.end());

            if(cur.size()==1)fen[0][i][j]=cur[0].second;
            else
            {
                for(int idx=1;idx<cur.size();idx++)
                {
                    int right=cur[idx].second;
                    int left;
                    if(idx==1)left=cur[0].second;
                    else left=cnt;

                    s[++cnt]={left,right};
                }
                fen[0][i][j]=cnt;
            }
        }
    }

    for(int i=1;i<=m;i++)
    {
        for(int j=1;j<=n;j++)
        {
            spars[1][i][j][0]=fen[0][j][i];
        }
        makespars(i,1);
        makefen(i,1);
    }

    cout<<cnt<<"\n";//return 0;

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cout<<fen[1][j][i]<<" ";
        }
        cout<<"\n";
    }

    for(int idx=n*m+1;idx<=cnt;idx++)
    {
        cout<<idx<<" = ";

        int left,right;

        tie(left,right)=s[idx];

        cout<<left<<" + ";
        cout<<right<<"\n";
    }



    return 0;
}
