#include <iostream>
#include <queue>

using namespace std;

const int MAXN = 2e5 + 5;
const int MAXM = 4e5 + 5;

int used[MAXN];
int n, m, q;

void speed()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct edge
{
    int from;
    int to;
    int price;

    edge(int _from, int _to, int _price)
    {
        from = _from;
        to = _to;
        price = _price;
    }

    edge()
    {
        from = 0;
        to = 0;
        price = 0;
    }
};

vector <edge> v[MAXN];

void read()
{
    int x, y, pr;

    cin >> n >> m >> q;

    for(int i = 0 ; i < m ; i++)
    {
        cin >> x >> y >> pr;

        v[x].push_back({x, y, pr});
        v[y].push_back({y, x, pr});
    }
}

void BFS(int start)
{
    queue <int> q;
    q.push(start);
    used[start] = 1;
    int node;
    edge nb;
    while(!q.empty())
    {
        node = q.front();
        q.pop();
        cout << node <<endl;
        for(int i = 0 ; i < (int)v[node].size() ; i++)
        {
            edge nb = v[node][i];
            if(used[nb.to] == 0)
            {
                //cout << nb.to << ' ' << nb.price <<endl;
                q.push(nb.to);
                used[nb.to] = max(used[node], nb.to);
                used[start] ++;
            }
            else
            {
                used[nb.to] = max(used[nb.to], used[node]);
            }
        }
    }
}

void AnsQueries()
{
    int k, x, ans = 1e9;

    for(int i = 0 ; i < q ; i++)
    {
        cin >> x >> k;

        for(int i = 0 ; i < v[x].size() ; i++)
        {
            ans = min(v[x][i].price, ans);
        }

        cout << ans <<endl;
        ans = 1e9;
    }


}

int main()
{
    speed();

    read();

    AnsQueries();

    return 0;
}
/*
13 18 7
1 2 4
1 3 1
2 4 6
2 5 4
2 6 2
3 6 3
3 10 4
4 7 6
5 8 5
6 8 2
10 11 6
7 8 5
11 12 7
12 8 6
7 9 5
9 13 6
13 8 1
5 6 3
13 1
7 1
3 1
13 1
12 1
8 1
5 1
*/
