#include<iostream>
#include<queue>
#include<vector>
#include<cstring>
#define MAXN 500010
using namespace std;
vector<pair<int,int>> edges[MAXN];
pair<int,int> ind[MAXN];
bool used[MAXN];
int parent[MAXN];
priority_queue<pair<int,int>> mst;
int maxx=0;
bool check(int lim, int n, int st, int k)
{
    queue<int> q;
    int cntr=0;
    q.push(st);
    memset(used,0,n+1);
    used[st]=1;
    while(!q.empty())
    {
        int curr=q.front();
        q.pop();
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i].first;
            int cost=edges[curr][i].second;
            if(cost<=lim && !used[now])
            {
                used[now]=1;
                cntr++;
                q.push(now);
            }
        }
        if(cntr>=k)return 1;
    }
    return 0;
}
int find(int curr)
{
    if(parent[curr]==curr)return curr;
    return parent[curr]=find(parent[curr]);
}
void unite(int a, int b)
{
    parent[b]=parent[a];
}
void getTree()
{
    while(!mst.empty())
    {
        int dist=-mst.top().first;
        int i=mst.top().second;
        mst.pop();
        int x=ind[i].first;
        int y=ind[i].second;
        if(find(x)!=find(y))
        {
            unite(x,y);
            edges[x].push_back({y,dist});
            edges[y].push_back({x,dist});
            maxx=max(maxx,dist);
        }
    }
}
int main()
{
    int n,m,q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m>>q;
    for(int i=0;i<m;i++)
    {
        int u,v,x;
        cin>>u>>v>>x;
        parent[u]=u;
        parent[v]=v;
        ind[i]={u,v};
        mst.push({-x,i});
    }
    getTree();
    for(int t=0;t<q;t++)
    {
        int st,k;
        cin>>st>>k;
        int l=1,r=maxx;
        while(l!=r)
        {
            int mid=(l+r)>>1;
            if(check(mid,n,st,k))r=mid;
            else l=mid+1;
        }
        cout<<l<<"\n";
    }
}