#include <bits/stdc++.h>
using namespace std;

const int maxn=2*1e5+5;

struct edge
{
    int x,y,z;
    edge(int _x,int _y,int _z)
    {
        x=_x;
        y=_y;
        z=_z;
    }

    bool operator<(const edge&e)const
    {
        return z<e.z;
    }
};

struct query
{
    int x,i;
    query(){}
    query(int _x,int _i)
    {
        x=_x;
        i=_i;
    }
    bool operator<(const query&q)const
    {
        return x<q.x;
    }
};

int n,m,q;
vector<edge> e;
multiset<query> s[maxn];

void read()
{
    cin>>n>>m>>q;
    for(int i=1;i<=m;i++)
    {
        int x,y,z;
        cin>>x>>y>>z;
        e.push_back({x,y,z});
    }

    sort(e.begin(),e.end());

    for(int i=1;i<=q;i++)
    {
        int x,z;
        cin>>x>>z;
        s[x].insert({z+1,i});
    }
}

int l[maxn];
int sz[maxn];
int ans[maxn];

void merge_(int i,int j)
{
    int y=j;
    /*cout<<"merge "<<i<<" "<<j<<endl;
    cout<<"!"<<endl;
    for(auto it=s[i].begin();it!=s[i].end();it++)
        cout<<(*it).x<<" "<<(*it).i<<endl;
    cout<<"!!"<<endl;
    for(auto it=s[j].begin();it!=s[j].end();it++)
        cout<<(*it).x<<" "<<(*it).i<<endl;*/

    for(auto it=s[i].begin();it!=s[i].end();it++)
    {
        //cout<<" in "<<endl;
        query curr=*it;
        //cout<<curr.x<<" "<<curr.i<<endl;
        s[j].insert(curr);
    }

    /*cout<<"- "<<endl;
    for(auto it=s[i].begin();it!=s[i].end();it++)
        cout<<(*it).x<<" "<<(*it).i<<endl;
    cout<<"-- "<<endl;
    for(auto it=s[j].begin();it!=s[j].end();it++)
        cout<<(*it).x<<" "<<(*it).i<<endl;

    cout<<endl;*/
}

void do_(int i,int val,int sz_)
{
    /*cout<<i<<" do "<<val<<" "<<sz_<<endl;
    for(auto it=s[i].begin();it!=s[i].end();it++)
        cout<<(*it).x<<" "<<(*it).i<<endl;*/
    while(s[i].size())
    {
        auto it=s[i].begin();
        //cout<<(*it).x<<endl;
        if((*it).x>sz_)break;

        ans[(*it).i]=val;
        s[i].erase(it);
    }
}

int find_l(int x)
{
    if(x==l[x])return x;
    return l[x]=find_l(l[x]);
}

void unite(int x,int y,int val)
{
    x=find_l(x);
    y=find_l(y);
    if(x!=y)
    {
        if(sz[x]>sz[y])swap(x,y);

        l[x]=y;
        sz[y]+=sz[x];

        merge_(x,y);
        do_(y,val,sz[y]);
    }
}

void solve()
{
    for(int i=1;i<=n;i++)
    {
        sz[i]=1;
        l[i]=i;
    }

    for(int i=0;i<m;i++)
    {
        unite(e[i].x,e[i].y,e[i].z);
    }

    for(int i=1;i<=q;i++)
        cout<<ans[i]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
    return 0;
}
