#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <bits/stdc++.h>


#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 4005
#define X first
#define Y second


using namespace std;


typedef long long ll;
typedef pair<int,int> pll;

struct edge
{
    int to, c;
    edge() {};
    edge(int _to, int _c)
    {
        to = _to;
        c = _c;
    }
    bool operator <(const edge& e)const
    {
        return c < e.c;
    }
};
vector <edge> v[maxn];
int n, m, q;

int dist[maxn];


void read()
{
    cin >> n >> m >> q;

    /**for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            dist[i][j] = INF;*/

    int a, b, c;
    for(int i = 1; i <= m; i++)
    {
        cin >> a >> b >> c;
        //dist[a][b] = min(dist[a][b] , c);
        //dist[b][a] = min(dist[b][a] , c);
        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }

    for(int i = 1; i <= n; i++)
        sort(v[i].begin() , v[i].end());
}


int k, x;
int dijkstra(int start, int l)
{
    priority_queue <pll, vector <pll>, greater <> > q;
    q.push({0, start});
    for(int i = 1; i <= n; i++)
        dist[i] = INF;
    dist[start] = 0;
    int ans = 0;
    int br = 0;

    while(q.size() != 0)
    {
        //cout << "[ " << q.top().Y << "," << q.top().X << " ], ";
        pll node = q.top();
        if(dist[node.Y] != 0)
            br++;
        ans = max(ans , dist[node.Y]);
        if(br >= l)
            return ans;
        q.pop();
        for(auto& nb : v[node.Y])
        {
            int e = max(node.X, nb.c);
            if(dist[nb.to] > e)
            {
                dist[nb.to] = e;
                q.push({e, nb.to});
            }
        }
    }
    return ans;
}



void solve()
{
    /**for(int i = 1; i <= n; i++)
        dijkstra(i);*/



    /**for(int i = 1; i <= n; i++)
        for(int j = 1; j <= n; j++)
            for(int k = 1; k <= n; k++)
            {
                dist[k][i] = min(dist[k][i] , max(dist[k][j] , dist[j][i]));
                dist[i][k] = min(dist[i][k] , max(dist[i][j] , dist[j][k]));
            }*/

    /**for(int i = 1; i <= n; i++ , cout << endl)
        for(int j = 1; j <= n; j++)
            cout << dist[i][j] << " ";*/

    /**for(int i = 1; i <= n; i++)
    {
        cout << i << "-> " << v[i].size() << ": ";
        for(auto& e : v[i])
            cout << e.to << " ";
        cout << endl;
    }*/


    while(q--)
    {
        cin >> x >> k;
        int curr = dijkstra(x, k);
        cout /**<< endl << "-> "*/ << curr << endl;
    }
}





int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
