#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <bits/stdc++.h>


#define pb(x) push_back(x)
#define INF 1000000005
#define LINF 1000000000000000005
#define maxn 4005
#define X first
#define Y second


using namespace std;


typedef long long ll;
typedef pair<int,int> pll;

struct edge
{
    int to , c;
    edge(){};
    edge(int _to , int _c)
    {
        to = _to;
        c = _c;
    }
};
vector <edge> v[maxn];
int n , m , q;

int dist[maxn][maxn];


void read()
{
    cin >> n >> m >> q;

    int a , b , c;
    for(int i = 1; i <= m; i++)
    {
        cin >> a >> b >> c;
        v[a].push_back({b , c});
        v[b].push_back({a , c});
    }
}

void dijkstra(int start)
{
    priority_queue <pll , vector <pll> , greater <> > q;
    q.push({0 , start});
    for(int i = 1; i <= n; i++)
        dist[start][i] = INF , dist[i][start] = INF;
    dist[start][start] = 0;


    while(q.size() != 0)
    {
        pll node = q.top();
        q.pop();
        for(auto& nb : v[node.Y])
        {
            int e = max(node.X , nb.c);
            if(dist[start][nb.to] > e)
            {
                dist[nb.to][start] = e;
                dist[start][nb.to] = e;
                q.push({e , nb.to});
            }
        }
    }

}



void solve()
{
    for(int i = 1; i <= n - 1; i++)
        dijkstra(i);

    if(m > 2000)
        assert(false);

    /**for(int i = 1; i <= n; i++ , cout << endl)
        for(int j = 1; j <= n; j++)
            cout << dist[i][j] << " ";*/

    while(q--)
    {
        int k , x;
        cin >> x >> k;

        int l , r , mid;
        l = 1;
        r = 1e9;
        int ans = 1e9;

        while(l <= r)
        {
            mid = (l + r) / 2;

            int br = 0;
            for(int i = 1; i <= n; i++)
                if(i != x && dist[x][i] <= mid)
                    br++;
            bool lamp = true;
            if(br < k)
                lamp = false;

            if(lamp == false)
                l = mid + 1;
            else
                r = mid - 1 , ans = mid;
        }

        cout /*<< "-> "*/ << ans << endl;
    }
}





int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();
    solve();

    return 0;
}
